#ifndef H_SENDMAILPLUGIN
#define H_SENDMAILPLUGIN

#include <BipCni.h>
#include <BipCci.h>

#if defined(__CCI_SOLARIS__) || defined(__CCI_HPUX__)|| defined(__CCI_LINUX__)/* 16/09/2001*/
#include <BipSampPluginUtil.h>
#endif

#ifdef WIN32
#ifdef _DEBUG
#include "/MemoryStatus/MemoryStatus.h"
#endif
#endif

#include "node_utils.h"
#include "SendMessage.h"

#ifndef max                                   
#define max(x, y) (((x) > (y)) ? (x) : (y))   
#endif                                        
                                              
#ifndef min                                   
#define min(x,y) (((x)<(y)) ? (x) : (y))      
#endif                                        

#ifndef FALSE
#define FALSE	0==1
#endif
#ifndef TRUE
#define TRUE	1==1
#endif

#if defined(__CCI_SOLARIS__) || defined(__CCI_HPUX__)|| defined(__CCI_LINUX__)/* 16/09/2001*/
/* ---------------------------------------------------------------- */
/*                     Internal constants                           */
/*                                                                  */
/* The interface expects some CciChar strings to be passed. These   */
/* have to be constructed from char strings using the supplied      */
/* utilities. The char constants are defined here along with the    */
/* static CciChar variables which will contain these constants      */
/* converted into CciChar format.                                   */
/*                                                                  */
/* ---------------------------------------------------------------- */
#define CONST_MQSERIES_INTEGRATOR_2       "MQSIv201"
const CciChar *constMQSeriesIntegrator2	= 0;

#define CONST_PLUGIN_NODE                 "SendMailPlugInNode"
const CciChar *constPlugInNode            = 0;

#define CONST_PLUGIN_NODE_FACTORY         "SendMailPlugInNodeFactory"
const CciChar *constPluginNodeFactory     = 0;

#define CONST_OUT                         "out"
const CciChar *constOut                   = 0;

#define CONST_FAILURE							"failure"
const CciChar *constFailure					= 0;

#define CONST_YES                         "yes"
const CciChar *constYes                   = 0;

#define CONST_MQMD                        "MQMD"
const CciChar *constMQMD                  = 0;

#define CONST_PUTDATE                     "PutDate"
const CciChar *constPutDate               = 0;

#define CONST_PUTTIME                     "PutTime"
const CciChar *constPutTime               = 0;

#define CONST_MSGID	                     "MsgId"
const CciChar *constMsgId	               = 0;

#define CONST_FROM	                     "From"
const CciChar *constFrom	               = 0;

#define CONST_MAILFROM	                  "MailFrom"
const CciChar *constMailFrom	            = 0;

#define CONST_TO			                  "To"
const CciChar *constTo							= 0;

#define CONST_MAILTO		                  "MailTo"
const CciChar *constMailTo						= 0;

#define CONST_CC									"Cc"
const CciChar *constCc							= 0;

#define CONST_MAILCC								"MailCc"
const CciChar *constMailCc						= 0;

#define CONST_BCC									"Bcc"
const CciChar *constBcc							= 0;

#define CONST_MAILBCC							"MailBcc"
const CciChar *constMailBcc					= 0;

#define CONST_SUBJECT							"Subject"
const CciChar *constSubject					= 0;

#define CONST_MAILSUBJECT						"MailSubject"
const CciChar *constMailSubject				= 0;

#define CONST_BODY								"Body"
const CciChar *constBody						= 0;

#define CONST_MAILBODY							"MailBody"
const CciChar *constMailBody					= 0;

#define CONST_LINE								"Line"
const CciChar *constLine						= 0;

#define CONST_MAILLINE							"MailLine"
const CciChar *constMailLine					= 0;

#define CONST_HIGHEST							"Highest"									/* 28/07/2001 */
const CciChar *constHighest					= 0;											/* 28/07/2001 */

#define CONST_HIGH								"High"										/* 28/07/2001 */
const CciChar *constHigh						= 0;											/* 28/07/2001 */

#define CONST_NORMAL								"Normal"										/* 28/07/2001 */
const CciChar *constNormal						= 0;											/* 28/07/2001 */

#define CONST_LOW									"Low"											/* 28/07/2001 */
const CciChar *constLow							= 0;											/* 28/07/2001 */

#define CONST_LOWEST								"Lowest"										/* 28/07/2001 */
const CciChar *constLowest						= 0;											/* 28/07/2001 */

#define CONST_SENDMAILERROR					"SendMailError"
const CciChar *constSendMailError			= 0;

#endif  
                                              
#define MAX_ATTR_NAME_LEN        128
#define MAX_NODE_NAME_LEN        128
#define MAX_STRING_SIZE          256
#define MAX_TERMINAL_NAME_LEN    256
#define CNI_TYPE_INTEGER         1
#define CNI_TYPE_STRING          2


#define MAX_ATTRIBUTE_NAME_LEN   128
#define MAX_NODE_NAME_LEN        128
#define MAX_TERMINAL_NAME_LEN    256

#define RC_NO_RECIPIENTS   2

#if defined(__CCI_SOLARIS__) || defined(__CCI_HPUX__)|| defined(__CCI_LINUX__)/* 16/09/2001*/
#define CCI_CHECK_RC()                                                                        \
   if (rc != CCI_SUCCESS) {                                                                   \
     if (rc == CCI_EXCEPTION) cciRethrowLastException(0);                                     \
     else {                                                                                   \
       return;                                                                                \
     }                                                                                        \
   }
#else
#define CCI_CHECK_RC()                                                                        \
   if (rc != CCI_SUCCESS) {                                                                   \
     if (rc == CCI_EXCEPTION) cciRethrowLastException(0);                                     \
     else {                                                                                   \
       return;                                                                                \
     }                                                                                        \
   }
#endif


typedef struct attributeTblEntry {
   void*    next;                    /* Pointer to next entry */
   void*    valptr;                  /* Pointer to value */
   int      type;                    /* Value type */
   CciChar  name[MAX_ATTR_NAME_LEN]; /* Attribute name */
} ATTRIBUTE_TBL_ENTRY;


typedef struct terminalListEntry {
   void*        next;                        /* Pointer to next entry */
   CciTerminal* handle;                      /* Handle to terminal object */
   CciChar      name[MAX_TERMINAL_NAME_LEN]; /* Terminal name */
} TERMINAL_LIST_ENTRY;


typedef struct context {
   CciNode*             nodeObject;                  /* Handle for node object */
   ATTRIBUTE_TBL_ENTRY *attrListHead;                /* Head of linked list of attributes */
   ATTRIBUTE_TBL_ENTRY *attrListPrevious;            /* Previous entry in attribute list */
   TERMINAL_LIST_ENTRY *inputTerminalListHead;       /* Head of linked list of input terminal handles */
   TERMINAL_LIST_ENTRY *inputTerminalListPrevious;   /* Previous entry in input terminal list */
   TERMINAL_LIST_ENTRY *outputTerminalListHead;      /* Head of linked list of output terminal handles */
   TERMINAL_LIST_ENTRY *outputTerminalListPrevious;  /* Previous entry in output terminal list */
   CciChar              nodeName[MAX_NODE_NAME_LEN]; /* Node name */
   /**/
   FILE *debugFile;
   /**/
   char *SMTPHostName;
   unsigned short SMTPHostPort;                                               /* 27/04/2001 */
   char *SMTPFrom;
   char *SMTPFullFrom;
   char *SMTPMailFrom;
   /**/
   char *SendmailOptionalParms;
   /**/
   char BasicProperties;
   char *BasicBcc;
   char BasicPriority;                                                        /* 13/04/2001 */
} NODE_CONTEXT_ST;


/* Node Utility Functions */
ATTRIBUTE_TBL_ENTRY *insertAttributeTableEntry
(
   NODE_CONTEXT_ST *context,
   CciChar			 *nodeName, 
   CciChar			 *attributeName,
   int				  type
);


void *getInputTerminalHandle(
   NODE_CONTEXT_ST *context,
   CciChar*         terminalName
);


TERMINAL_LIST_ENTRY *insertInputTerminalListEntry
(
   NODE_CONTEXT_ST *context,
   CciChar         *terminalName 
);

void *getOutputTerminalHandle(
   NODE_CONTEXT_ST	*context,
   CciChar				*terminalName
);


TERMINAL_LIST_ENTRY *insertOutputTerminalListEntry
(
   NODE_CONTEXT_ST *context,
   CciChar			 *terminalName 
);



/* Node Implementation Functions */
void *createNodeContext( void    *factoryObject,
                         CciChar *nodeName,
                         void    *nodeObject );

int getAttributeName( CciContext* context,
                      int         index,
                      CciChar*    buffer,
                      int         bufsize );

int setAttribute( CciContext* context,
                  CciChar*    attrName,
                  CciChar*    attrValue );

int getAttribute( CciContext* context,
                  CciChar*    attrName,
                  CciChar*    buffer,
                  int         bufsize );


void evaluate( CciContext *context,
               CciMessage *destinationList,
               CciMessage *exceptionList,
               CciMessage *message );

static char *getErrorString(int rc);														/* 28/07/2001 */
static char GetPriorityNumber(CciChar *Priority);                             /* 13/04/2001 */

#endif

