#include <malloc.h>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef __LCLINT__																					/* 02/08/2001 */
#ifdef SENDMAIL																					/* 02/08/2001 */
#undef SENDMAIL																					/* 02/08/2001 */
#define SMTP																						/* 02/08/2001 */
#endif																								/* 02/08/2001 */
#endif																								/* 02/08/2001 */

#include "SendMessage.h"

#ifdef SENDMAIL
/*******************************************/
/* sendmail is available                   */
/*******************************************/
char *SendEmailMessage( char *SendmailOptParms, 
                        unsigned short Parm1NotUsed,                          /* 27/04/2001 */
                        char *MailFrom, 
                        char *MailTo, 
                        char *MailCc, 
                        char *MailBcc, 
                        char *MailSubject,
                        char *MailDate,
                        char *MailMsgId,
                        char *MailBody,
                        char  MailPriority,                                   /* 13/04/2001 */
                        int  *Reason )
{
   int rc = 0;

   rc = sendmailSendMessage(SendmailOptParms,
                            MailFrom, 
                            MailTo, 
                            MailCc, 
                            MailBcc, 
                            MailSubject,
                            MailDate,
                            MailMsgId,
                            MailBody,
                            MailPriority);                                    /* 13/04/2001 */
   if (rc != 0) {
      *Reason = rc;
      return(char *)SendmailErrorString(rc);
   }
         
   *Reason = 0;
   return(char *)"";
}

#else
/******************************************************************************* 28/07/2001 */
/* Windows NT/2000 or AIX, Sun Solaris without sendmail                        * 28/07/2001 */
/******************************************************************************* 28/07/2001 */
/*@ null @*/char *SendEmailMessage( char *SMTPhost,									/* 28/07/2001 */
                        unsigned short SMTPport,                              /* 27/04/2001 */
                        char *MailFrom, 
                        char *MailTo, 
                        char *MailCc, 
                        char *MailBcc, 
                        char *MailSubject,
                        char *MailDate,
                        char *MailMsgId,
                        char *MailBody,
                        char  MailPriority,                                   /* 13/04/2001 */
                        int  *Reason )
{
   int rcSmtp = 0;
	SMTPINFO *SMTPinfo	= NULL;
   char *SMTPstring		= NULL;

	SMTPinfo = SmtpInit(SMTPhost, SMTPport, &rcSmtp);									/* 25/06/2001 */

	if(rcSmtp != 0) {																				/* 25/06/2001 */
      *Reason = rcSmtp;																			/* 25/06/2001 */
		free(SMTPinfo);																			/* 28/07/2001 */
      return(char *)SMTPErrorString(rcSmtp);												/* 25/06/2001 */
	}																									/* 25/06/2001 */

   rcSmtp = SmtpSendMessage( SMTPinfo, 
                             MailFrom, 
                             MailTo, 
                             MailCc, 
                             MailBcc, 
                             MailSubject, 
                             MailDate, 
                             MailMsgId, 
                             MailBody,
                             MailPriority,
									  &SMTPstring);                                   /* 13/04/2001 */

   if (rcSmtp != SMTP_SUCCESS) {
      *Reason = rcSmtp;
		free(SMTPinfo);																			/* 28/07/2001 */
      return(char *)SMTPstring;
   }

	rcSmtp = SmtpCleanUp();																		/* 25/06/2001 */
																			
	if (rcSmtp != SMTP_SUCCESS) {																/* 25/06/2001 */
      *Reason = rcSmtp;																			/* 25/06/2001 */
		free(SMTPinfo);																			/* 28/07/2001 */
      return(char *)SMTPstring;																/* 25/06/2001 */
   }																									/* 25/06/2001 */

   *Reason = SMTP_SUCCESS;
	free(SMTPinfo);																				/* 28/07/2001 */
   return(char *)"";
}

#endif

static char *ShortName[] = {
       "   ",
       "Jan", "Feb", "Mar",
       "Apr", "May", "Jun",
       "Jul", "Aug", "Sep",
       "Oct", "Nov", "Dec"
    };

char *MonthShortName(int i)
{
    return(i < 1 || i > 12) ? ShortName[0] : ShortName[i];
}
