#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sendmailSendMessage.h"

#if defined (AIX) || defined (SUN) || defined (HPUX)	|| defined (LINUX)			/* 16/09/2001 */
#include <sysexits.h>
#include "spawn.h"
#endif 

#ifdef WIN32
#include <process.h>
#endif

int sendmailSendMessage(char *SendmailOptParms,
                        char *MailFrom, 
                        char *MailTo, 
                        char *MailCc, 
                        char *MailBcc, 
                        char *MailSubject,
                        char *MailDate,
                        char *MailMsgId,
                        char *MailBody,
                        char Priority)                                        /* 13/04/2001 */
{
   char *tempFileName   = NULL;
   FILE *tempFileStream = NULL;
   static char systemBuffer[10240];
   int rc = -1;

   memset(systemBuffer, 0, sizeof(systemBuffer));

   tempFileName = (char *)malloc((2 * L_tmpnam) * sizeof(char));
   
   if( ( tempFileName = tmpnam( tempFileName ) ) == NULL ) {
#ifdef _DEBUG
      printf( "Cannot create a unique filename\n" );
#endif
      return -1;
   }

   if (( tempFileStream = fopen(tempFileName, "w")) == NULL ) {
#ifdef _DEBUG
      printf( "Cannot create file handle\n" );
#endif
      free(tempFileName);
      return -1;
   }

   fprintf(tempFileStream, "Subject: %s\n", MailSubject);
   
   if (MailFrom[0] != '\0')
      fprintf(tempFileStream, "From: %s\n", MailFrom);

   if (MailTo[0] != '\0')
	   fprintf(tempFileStream, "To: %s\n", MailTo);

	if (MailCc[0] != '\0')
	   fprintf(tempFileStream, "Cc: %s\n", MailCc);

	if (MailBcc[0] != '\0')
	   fprintf(tempFileStream, "Bcc: %s\n", MailBcc);

	fprintf(tempFileStream, "Date: %s", MailDate);

   if (Priority < 1 || Priority > 5 || Priority == 3) {                       /* 13/04/2001 */
      fprintf(tempFileStream, "Priority: Normal\n");                          /* 13/04/2001 */
   }                                                                          /* 13/04/2001 */
   else if (Priority == 1 || Priority == 2) {                                 /* 13/04/2001 */
      fprintf(tempFileStream, "Priority: High\n");                            /* 13/04/2001 */
   }                                                                          /* 13/04/2001 */
   else if (Priority == 4 || Priority == 5) {                                 /* 13/04/2001 */
      fprintf(tempFileStream, "Priority: Low\n");                             /* 13/04/2001 */
   }                                                                          /* 13/04/2001 */

	if (MailMsgId[0] != '\0')
	    fprintf(tempFileStream, "Message-ID: %s\n", MailMsgId);

   if (Priority < 1 || Priority > 5) {                                        /* 13/04/2001 */
      fprintf(tempFileStream, "X-Priority: 3 (Normal)\n");                    /* 13/04/2001 */
   }                                                                          /* 13/04/2001 */
   else {                                                                     /* 13/04/2001 */
      fprintf(tempFileStream, "X-Priority: %d (%s)\n", Priority, GetPriorityName(Priority));/* 13/04/2001 */
   }                                                                          /* 13/04/2001 */

   fprintf(tempFileStream,"X-mailer: %s\n\n", XMAILER);
   fprintf(tempFileStream,"%s", MailBody);

   fclose(tempFileStream);

if (SendmailOptParms[0] != '\0')
   sprintf(systemBuffer,"sendmail %s -t < %s", SendmailOptParms, tempFileName);
else
   sprintf(systemBuffer,"sendmail -t < %s", tempFileName);

#ifdef _DEBUG
   printf("systemBuffer: %s\n", systemBuffer);
#endif

#ifdef LINUX																						/* 16/09/2001 */
   rc = spawnl(_P_WAIT, "/bin/sh", "sh", "-c", systemBuffer, NULL);				/* 16/09/2001 */
#else																									/* 16/09/2001 */
   rc = spawnl(_P_WAIT, "/usr/bin/sh", "sh", "-c", systemBuffer, NULL);
#endif																								/* 16/09/2001 */

   if( remove(tempFileName) == -1 ) {
#ifdef _DEBUG
      printf( "Could not delete %s\n", tempFileName );
#endif
      free(tempFileName);
      return -1;
   }
#ifdef _DEBUG
   else 
      printf("File deleted!\n");
#endif

   free(tempFileName);
   return rc;
}


char *SendmailErrorString(int rc)
{
   switch(rc) {
#if defined (AIX) || defined (SUN) || defined (HPUX) || defined (LINUX)
      case EX_CANTCREAT:
         return("The sendmail command cannot create a file that the user specified.");
         break;
      case EX_CONFIG:
         return("An error was found in the format of the configuration file.");
         break;
#if defined (AIX)
      case EX_DB:
         return("An error occurred while trying to gain access to a database.");
         break;
#endif
      case EX_IOERR:
         return("An error occurred during I/O.");
         break;
      case EX_NOHOST:
         return("The sendmail command could not recognize the specified host name.");
         break;
      case EX_NOPERM:
         return("The user does not have permission to perform the requested operation.");
         break;
      case EX_NOUSER:
         return("The sendmail command could not recognize a specified user ID.");
         break;
      case EX_OK:
         return("The sendmail command successfully completed.");
         break;
      case EX_OSERR:
         return("A temporary operating system error occurred. An example of such an error is a failure to create a new process.");
         break;
      case EX_OSFILE:
         return("A system file error occurred. For example, a system file (such as /etc/passwd) does not exist, cannot be opened, or has another type of error preventing it from being used.");
         break;
      case EX_PROTOCOL:
         return("The remote system returned something that was incorrect during a protocol exchange.");
         break;
      case EX_SOFTWARE:
         return("An internal software error occurred (including bad arguments).");
         break;
      case EX_TEMPFAIL:
         return("The sendmail command could not create a connection to a remote system. Try the request again later.");
         break;
      case EX_UNAVAILABLE:
         return("A service or resource that the sendmail command needed was not available.");
         break;
      case EX_USAGE:
         return("The command syntax was not correct.");
#endif
      default:
        return("Unknown sendmail error");
        break;
   }

   return("Unknown sendmail error");
}


char *GetPriorityName(char Priority)                                          /* 13/04/2001 */
{
   static char *PriorityArray[] = {
       "      ",
       "Higest",
       "High  ", 
       "Normal", 
       "Low   ", 
       "Lowest",

    }; 

    return(Priority < 1 || Priority > 5) ? PriorityArray[3] : PriorityArray[Priority];
}
