#ifndef H_SMTP
#define H_SMTP

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#ifdef WIN32
   #include <windows.h>
   #include <winsock.h>
#endif


#if defined (AIX) || defined(SUN) || defined(HPUX)	|| defined (LINUX)			/* 16/09/2001 */
   #include <sys/types.h>
   #include <sys/socket.h>
   #include <unistd.h>
   #include <netinet/in.h>
   #include <netdb.h>

   typedef int SOCKET;   
   
   #define INVALID_SOCKET  -1
   #define SOCKET_ERROR    -1
#endif

#define XMAILER                  "IBM MQSeries Integrator V2 PlugIn node"

#define TCP_OK			            0
#define TCP_ERROR		            100
#define TCP_BADPORT              101
#define TCP_HOSTUNKNOWN          102
#define TCP_NOMORESOCKET         103
#define TCP_CONNECTFAILED        104
#define TCP_INSMEMORY            105

#define SMTP_SUCCESS             0    /* Success !!                       */
#define SMTP_UNEXPECTEDANSWER    1000 /* answer was not expected          */
#define SMTP_SERVICECLOSED       1001 /* service unavailable              */
#define SMTP_NOTIMPLEMENTED      1002 /* host recognize but can't exec cmd*/
#define SMTP_MIMENOTSUPPORTED    1003 /* server doesn't support MIME ext. */
#define SMTP_SERVERCANTEXECUTE   1004 /* refused by server                */
#define SMTP_CANTCONNECT         1005 /* can not connect to the server    */
#define SMTP_DATAERROR           1006 /* Error during communication       */
#define SMTP_SYNTAXERROR         1007 /* Bad parameters                   */
#define SMTP_STORAGEEXCEDED      1008 /* server limits exceeded           */
#define SMTP_UNKNOWNUSER         1009 /* unknown destinee                 */
#define SMTP_FORWARDED           1010 /* address OK,unknwon on this server*/

#define SMTP_SEPARATOR           ';'  /* semi colon character */

#ifndef SizeOfTab
#  define SizeOfTab(x)   (sizeof x / sizeof (*x))
#endif


struct S_TnProto 
{
   char *String;
   int  Code;
};


struct S_SmtpProto
{
   char              *Cmd;
   struct S_TnProto  Answer[16];
};


typedef struct tagSMTP {
	char  HostName[255];
	struct sockaddr_in   A;
   struct hostent      *H;
} SMTPINFO;


enum{ _SMTP_CONNECT=0, 
      _SMTP_HELO,  
      _SMTP_MAILFROM,
      _SMTP_MAILFROMSIZE,
      _SMTP_RCPTTO,    
      _SMTP_DATA,  
      _SMTP_ENDOFDATA, 
      _SMTP_VERIFY,  
      _SMTP_QUIT,
      _SMTP_REST  
};


int SmtpSendMessage(SMTPINFO	*SMTPinfo,
                    char		*MailFrom, 
                    char		*MailTo, 
                    char		*MailCc, 
                    char		*MailBcc, 
                    char		*MailSubject,
                    char		*MailDate,
                    char		*MailMsgId,
                    char		*MailBody,
                    char		 MailPriority,
						  char	  **Rbuffer);


int TcpInit(void);
int TcpConnect(SOCKET *S, SMTPINFO *SMTPinfo);
int TcpClose(SOCKET S);
int TcpCleanUp(void);

int TcpSend(SOCKET S, char *Buffer, int BufferSize);
int TcpRecv(SOCKET S, char *Buffer, int BufferSize);

SMTPINFO *SmtpInit(char *SMTPhost, unsigned short SMTPhostPort, int *Reason);
int SmtpCleanUp(void);

int SmtpTcpSend(SOCKET S, char *Buffer, int BufferSize);
int SmtpGetRc(struct S_SmtpProto SmtpProto, char *Buffer);

int SmtpSendRcpt(SOCKET S, char *pTo, char *R);
int SmtpSendTo(SOCKET S, char *pTo);
int SmtpSendCc(SOCKET S, char *pCc);
int SmtpSendPriority(SOCKET S, char Priority);                                /* 09/04/2001 */
int SmtpSendXPriority(SOCKET S, char Priority);                               /* 09/04/2001 */

char *GetPriorityName(char Priority);                                         /* 09/04/2001 */

char *SMTPErrorString(int rc);
char *TCPIPErrorString(int rc);																/* 25/06/2001 */


#if defined (AIX) || defined(SUN) || defined(HPUX)	|| defined (LINUX)			/* 16/09/2001 */
int closesocket(SOCKET S);
#endif


#endif

